//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "TJabber.h"
//---------------------------------------------------------------------------
static inline TJabber *ValidCtrCheck()
{
	return new TJabber(NULL);
}
//---------------------------------------------------------------------------
__fastcall TJabber::TJabber(TComponent* Owner)
	: TComponent(Owner)
{
	PROTOCOL="19981001";
	InputBuffer="";
	OutputBuffer="";
	Connected=false;
	CauseRosterEvent=false;

	PClientName="Windows Jabber Client";
	PClientPriority=10;
	PClientStatus="I'm Online now";

	PUserName="";
	PUserNickName="";
	PUserPassword="";

	MainRoster=new roster;
	GroupList=new group;
}
//---------------------------------------------------------------------------
namespace Tjabber
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TJabber)};
		RegisterComponents("Sean", classes, 0);
	}
}
//---------------------------------------------------------------------------
void __fastcall TJabber::LoadData(AnsiString Input)
{
	AnsiString OverFlow;

 	tag* Tag=new tag;
	bool Whole;
	bool Repeat=true;

	InputBuffer+=Input;

	while(Repeat){
		OverFlow=ParseXML(Tag,Whole,InputBuffer);

		if (!Tag->Name.IsEmpty() && Tag->Name == "j" && Whole){
		     	InputBuffer=OverFlow;
		        HandleCommand(Tag);
			Repeat=true;
		} else {
			if (!Tag->Name.IsEmpty() && Tag->Name != "j")
	        		InputBuffer=OverFlow;
			Repeat=false;
		}
	}

}
//---------------------------------------------------------------------------
int __fastcall TJabber::Connect(void)
{
	if (Connected)
		return 0;
	Connected=true;


	// Send first connection packet
	OutputBuffer+="<j type='connection'><type>client</type><ver>";
	OutputBuffer+=ClientName;
	OutputBuffer+="</ver><protocol>";
	OutputBuffer+=PROTOCOL;
	OutputBuffer+="</protocol></j>";
	//

	// Send login packet
	OutputBuffer+="<j type='login'><user>";
	OutputBuffer+=PUserName;
	OutputBuffer+="</user><pass>";
	OutputBuffer+=PUserPassword;
	OutputBuffer+="</pass><nick>";
	OutputBuffer+=PUserNickName;
	OutputBuffer+="</nick></j>";
	//

	// Send the initial Status packet
	OutputBuffer+="<j type='status'><say type='online'>";
	OutputBuffer+=PClientStatus;
	OutputBuffer+="</say><priority>";
	OutputBuffer+=AnsiString(PClientPriority);
	OutputBuffer+="</priority><status>normal</status></j>";
	//

	SendData();  //Send the data

	return 1;
}
//---------------------------------------------------------------------------
int __fastcall TJabber::Disconnect(void)
{
	if (!Connected)
		return 0;

	OutputBuffer+="<j type='logout'></j>";

	SendData();  //Send the packet

	Connected=false;

	delete MainRoster;
	delete GroupList;
	MainRoster=new roster;
	GroupList=new group;

	return 1;
}
//---------------------------------------------------------------------------
void __fastcall TJabber::SendData(void)
{
	if (OnSendData && Connected)
		OnSendData(this,OutputBuffer);

	OutputBuffer="";   // Assume data was sent.  If it wasn't, tough luck.
}
//---------------------------------------------------------------------------
void __fastcall TJabber::SetPClientStatus(AnsiString Status)
{
	PClientStatus=Status;
	if (Connected){
		OutputBuffer+="<j type='status'><say>" + PClientStatus + "</say></j>";
		SendData();
	}
}
//---------------------------------------------------------------------------
void __fastcall TJabber::SetPClientPriority(int Pri)
{
	PClientPriority=Pri;
	if (Connected){
		OutputBuffer+="<j type='status'><priority>" + AnsiString(PClientPriority) + "</priority></j>";
		SendData();
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TJabber::ParseXML(tag* Tag, bool& Whole, AnsiString XML)
{

	// Whole is used to confirm that an entire tag was found

	Whole=true;

	AnsiString T="";
	AnsiString Attrib="";
	AnsiString Data="";

    // Get rid of anything before the first <
	while(!XML.IsEmpty() && XML[1] != '<')
    	XML.Delete(1,1);
    if (!XML.IsEmpty()) XML.Delete(1,1);  //Delete the <

    // Get rid of whitespace
	while(!XML.IsEmpty() && XML[1] == ' ')
    	XML.Delete(1,1);

    // Get the tag out
    while(!XML.IsEmpty() && XML[1] !=' ' && XML[1] != '/' && XML[1] != '>'){
		T+=XML[1];
        XML.Delete(1,1);
    }

    // Get rid of whitespace
	while(!XML.IsEmpty() && XML[1] == ' ')
    	XML.Delete(1,1);

    char LastChar=NULL;

    // Get the Attribs out
    while(!XML.IsEmpty() && XML[1] != '>'){
    	LastChar=XML[1];
		Attrib+=XML[1];
        XML.Delete(1,1);
    }
    if (!XML.IsEmpty()) XML.Delete(1,1);  // Trash that last >
    if (LastChar == '/') Attrib.Delete(Attrib.Length(),1);

    bool Quote=false;
    bool A=false;
    bool V=false;
    AnsiString AN="";
    AnsiString AV="";
    attribute* NewA=new attribute;
    attribute* PrevA=NULL;

    Tag->Attribs=NewA;
    if (!T.IsEmpty() && T[1] == '/')
    	T="";

    Tag->Name=T;

    // Handle those Attribs
    while(!Attrib.IsEmpty()){
    	if (!Quote && V && !A && !AV.IsEmpty() && Attrib[1] == ' '){
            NewA->Name=AN;
            NewA->Value=AV;
            PrevA=NewA;
            NewA->Next=new attribute;
            NewA=NewA->Next;

            AN="";
            AV="";
            V=false;
            continue;
        }

		if (!Quote && Attrib[1] == ' '){
        	Attrib.Delete(1,1);
            continue;
        }
        if (!Quote && !V && A && Attrib[1] == '='){
        	A=false;
        	V=true;
            Attrib.Delete(1,1);
            continue;
        }
        if (!Quote && (Attrib[1] == '\'' || Attrib[1] == '\"')){
         	Quote=true;
            Attrib.Delete(1,1);
            continue;
        }
        if (Quote && (Attrib[1] == '\'' || Attrib[1] == '\"')){
         	Quote=false;
            Attrib.Delete(1,1);
            continue;
        }
        if (Attrib[1] == '\\')
        	Attrib.Delete(1,1);

        if (Attrib.IsEmpty())
        	continue;

        if (!A && !V)
        	A=true;

        if (A)
        	AN+=Attrib[1];

    	if (V)
        	AV+=Attrib[1];

        Attrib.Delete(1,1);

    }
    if (!AN.IsEmpty() && !AV.IsEmpty()){
    	NewA->Name=AN;
        NewA->Value=AV;
        NewA->Next=NULL;
    } else
    	if (PrevA){
		    NewA=PrevA;
		    delete(NewA->Next);
		    NewA->Next=NULL;
	    } else {
        	Tag->Attribs=NULL;
        }

    // If this is not an empty tag, look for the end
    if (LastChar != '/'){
		AnsiString End=("</" + T + ">");
		int Last=XML.Pos(End);
        if (Last>0){
	        for(int i=1; i<Last; i++){
	        	Data+=XML[1];
	            XML.Delete(1,1);
	        }

            Last=XML.Pos(End);
           	XML.Delete(Last,End.Length());
        } else {
        	Data="";
        	Whole=false;
        }
    }

    Tag->Contents=Data;

    return(XML);
}
//---------------------------------------------------------------------------
void __fastcall TJabber::HandleCommand(tag* Tag)
{
	attribute* P=Tag->Attribs;
 	tag* Command=new tag;
	
	bool Whole;
	AnsiString XML=Tag->Contents;

	AnsiString Type=AttrName(P,"type");
	AnsiString C;

	if (Type == "connection"){
		AnsiString Ver="",Proto="";
		XML=ParseXML(Command,Whole,XML);
		while(Whole){
			C=Command->Name;

			if (C == "ver")
				Ver=Command->Contents;
			if (C == "protocol")
				Proto=Command->Contents;
			XML=ParseXML(Command,Whole,XML);
		}
		Ver=DecodeString(Ver);
		Proto=DecodeString(Proto);
		if (OnServerInfo)
			OnServerInfo(this,Ver,Proto);
        }

        if (Type == "message"){
        	AnsiString NickName="", From="",Subject="",Priority="",Thread="",Message="",Ext="";

		XML=ParseXML(Command,Whole,XML);
		while(Whole){
			C=Command->Name;

	             	if (C == "from"){
        	        	From=Command->Contents;
				NickName=AttrName(Command->Attribs,"name");
			}
	                if (C == "subject")
	                	Subject=Command->Contents;
	             	if (C == "thread")
	                	Thread=Command->Contents;
	                if (C == "say")
	                	Message=Command->Contents;
	                if (C == "ext")
	                	Ext=Command->Contents;
	                if (C == "priority")
	                	Priority=Command->Contents;
	                XML=ParseXML(Command,Whole,XML);
	        }
		NickName=DecodeString(NickName);
	  	From=DecodeString(From);
	        Subject=DecodeString(Subject);
        	Message=DecodeString(Message);

		if (OnNewNote)
			OnNewNote(this,From,NickName,Ext,Thread,Priority,Subject,Message);
        }

        if (Type == "roster"){
        	AnsiString UserName, Group;

		bool AssumeGroupListOnly=false;

		XML=ParseXML(Command,Whole,XML);
		while(Whole){
			C=Command->Name;

			UserName="";
			Group="";

	                if (C == "group"){
				Group=AttrName(Command->Attribs,"name");
				UserName=Command->Contents;
			}

			if (UserName.IsEmpty()){
				AssumeGroupListOnly=true;
				GroupAdd(GroupList,Group);
			} else {
				UserName=DecodeString(UserName);
			  	Group=DecodeString(Group);
				RosterAdd(MainRoster,Group,UserName);
			}

	                XML=ParseXML(Command,Whole,XML);
	        }

		if (AssumeGroupListOnly)
			FetchRosterGroups();
		else
			if (OnRosterUpdate)
				OnRosterUpdate(this);
        }

        if (Type == "status"){
            //ShowJabberNote("STATUS","STATUS","1","","",XML);
        }

}
//---------------------------------------------------------------------------
AnsiString __fastcall TJabber::DecodeString(AnsiString String)
{
	const int Num=5;
	AnsiString Search[Num];
    AnsiString Replace[Num];

    Search[0]="&apos;";
    Replace[0]="\'";
    Search[1]="&quot;";
    Replace[1]="\"";
	Search[2]="&amp;";
    Replace[2]="&";
    Search[3]="&lt;";
    Replace[3]="<";
    Search[4]="&gt;";
    Replace[4]=">";

    int Pos;

    for (int i=0; i<Num; i++){
    	Pos=String.AnsiPos(Search[i]);
		while(Pos>0){
            String.Delete(Pos,Search[i].Length());
            String.Insert(Replace[i],Pos);
			Pos=String.AnsiPos(Search[i]);
        }
    }

    AnsiString Temp="";

    for (int i=1; i<=String.Length(); i++){
    	if (String[i]=='\n')
        	Temp+='\r';
        Temp+=String[i];
    }

    String=Temp;

	return String;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TJabber::AttrName(attribute* Attrib, AnsiString Name)
{
	// Find Name in Attrib and return Value

	AnsiString Value="";
	attribute* P=Attrib;
	bool Found=false;

	while(P != NULL && !Found){
		if (P->Name == Name){
			Value=P->Value;
			Found=true;
		}
		P=P->Next;
	}
	return Value;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TJabber::AttrValue(attribute* Attrib, AnsiString Value)
{
	// Find Value in Attrib and return Name

	AnsiString Name="";
	attribute* P=Attrib;
	bool Found=false;

	while(P != NULL && !Found){
		if (P->Value == Value){
			Name=P->Name;
			Found=true;
		}
		P=P->Next;
	}
	return Name;
}
//---------------------------------------------------------------------------
void __fastcall TJabber::RosterAdd(roster* Roster, AnsiString Group, AnsiString UserName)
{
	// Add Group and UserName to Roster

	roster* P=Roster;
	roster* Prev=NULL;

	bool Found=false;

	while(P != NULL && !Found){
		if (P->UserName == UserName && P->Group == Group){
			Found=true;
		}
		Prev=P;
		P=P->Next;
	}
	if (!Found){
		Prev->Next=new roster;
		P=Prev->Next;
		P->UserName=UserName;
		P->Group=Group;
		GroupAdd(GroupList,Group);
	}
}
//---------------------------------------------------------------------------
void __fastcall TJabber::GroupAdd(group* G, AnsiString Group)
{
	// Add Group to group G

	group* P=G;
	group* Prev=NULL;

	bool Found=false;

	while(P != NULL && !Found){
		if (P->Group == Group){
			Found=true;
		}
		Prev=P;
		P=P->Next;
	}
	if (!Found && Group != "_all"){   // The Group != "_all" part is to skip Jer's test thing
		Prev->Next=new group;
		P=Prev->Next;
		P->Group=Group;
	}
}
//---------------------------------------------------------------------------
void __fastcall TJabber::RosterList(AnsiString Group,TStringList* List)
{
	// Return a TStringList with Group in it

	roster* P=MainRoster;

	while(P != NULL){
		if (!P->Group.IsEmpty() && P->Group == Group){
			List->Add(P->UserName);
		}
		P=P->Next;
	}

}
//---------------------------------------------------------------------------
void __fastcall TJabber::FetchRosterGroups(void)
{
	// Start getting a clean roster listing.  This means deleting what we have and starting over
	// This will only occur after a request to get a new list of current roster groups.

	delete MainRoster;
	MainRoster=new roster;

	group* P=GroupList;

	while(P != NULL){
		OutputBuffer+="<j type='roster'><get group='" + P->Group + "'/></j>";
		P=P->Next;
	}
	SendData();
	CauseRosterEvent=true;
}
//---------------------------------------------------------------------------
void __fastcall TJabber::FetchRoster(void)
{
	// Start getting a clean roster listing.  This means deleting what we have and starting over
	// This will only occur after a request from the user/client calling FetchRoster()
	// If there are any groups, FetchRosterGroups() will be called by the command handler

	delete GroupList;
	GroupList=new group;

	OutputBuffer+="<j type='roster'><get/></j>";
	SendData();
}
//---------------------------------------------------------------------------
void __fastcall TJabber::RosterGroups(TStringList* List)
{
	// Return a TStringList with list of groups

	group* P=GroupList;

	while(P != NULL){
		if (!P->Group.IsEmpty())
			List->Add(P->Group);
		P=P->Next;
	}

}
//---------------------------------------------------------------------------
void __fastcall TJabber::SendJabberNote(AnsiString To, AnsiString ToNickName, AnsiString Ext, AnsiString Thread, AnsiString Priority, AnsiString Subject, AnsiString Message)
{
	// Send a Jabber Note
	OutputBuffer+="<j type='message'>";
	OutputBuffer+="<to name='";
	OutputBuffer+=ToNickName;
	OutputBuffer+="'>";
	OutputBuffer+=To;
	OutputBuffer+="</to><thread>";
	OutputBuffer+=Thread;
	OutputBuffer+="</thread><priority>";
	OutputBuffer+=Priority;
	OutputBuffer+="</priority><subject>";
	OutputBuffer+=Subject;
	OutputBuffer+="</subject><say>";
	OutputBuffer+=Message;
	OutputBuffer+="</say></j>";
	//

	SendData();  //Send the data
}
//---------------------------------------------------------------------------
void __fastcall TJabber::RosterAddUser(AnsiString Group,AnsiString UserName)
{
	// Add UserName to the roster Group on the server side.  Then request a roster update so a new roster is sent to the client

	OutputBuffer+="<j type='roster'><add group='" + Group + "'>" + UserName + "</add></j>";
	OutputBuffer+="<j type='roster'><get group='" + Group + "'/></j>";
	SendData();
}
//---------------------------------------------------------------------------